/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2009-2017 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package client;
import javax.xml.ws.WebServiceRef;
import javax.xml.ws.Service;
import javax.xml.ws.BindingProvider;
import com.example.calculator.CalculatorService;
import com.example.calculator.Calculator;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class SOAPWebConsumer {
 //   @WebServiceRef(wsdlLocation="http://localhost:8080/bare_doc_literal-bc_consumer_se_provider/webservice/CalculatorService?WSDL")
//    static CalculatorService service;
    CalculatorService service = new CalculatorService();
    private static SimpleReporterAdapter stat =
                new SimpleReporterAdapter("jbi");
	private static String testId = "jbi-serviceengine/bare_doc_literal/bc_consumer_se_provider";
    public static void main (String[] args) {
        stat.addDescription(testId);
	SOAPWebConsumer client = new SOAPWebConsumer();
	client.addUsingSOAPConsumer();
        stat.printSummary(testId);
    }

    private void addUsingSOAPConsumer() {
	com.example.calculator.Calculator port= null;
	try {

		System.out.println(" After creating CalculatorService");

                port = service.getCalculatorPort();
		System.out.println(" After getting port");

		// Get Stub
		BindingProvider stub = (BindingProvider)port;
		String endpointURI ="http://localhost:12011/calculatorendpoint";
		stub.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY,
		      endpointURI);
		System.out.println(" After setting endpoint address URI");
	        System.out.println(" Using SOAP binding's consumer to add 500 + 50 = " + port.add(50));
	        stat.addStatus(testId, stat.PASS);
		System.out.println(" No Exception thrown");

	} catch(Exception e) {
		//e.printStackTrace();
		if(e instanceof javax.xml.ws.soap.SOAPFaultException) 
                	stat.addStatus(testId, stat.FAIL);
		else {
	        	stat.addStatus(testId, stat.FAIL);
			System.out.println(" SOAPFaultException Not thrown");
		}
	}
    }
}
