/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the "License").  You may not use this file except
 * in compliance with the License.
 *
 * You can obtain a copy of the license at
 * glassfish/bootstrap/legal/CDDLv1.0.txt or
 * https://glassfish.dev.java.net/public/CDDLv1.0.html.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * HEADER in each file and include the License file at
 * glassfish/bootstrap/legal/CDDLv1.0.txt.  If applicable,
 * add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your
 * own identifying information: Portions Copyright [yyyy]
 * [name of copyright owner]
 */

package testmbeans;

/**
 * Interface MicrowaveOven
 * MicrowaveOven Description
 * @author kedarm
 */
public interface MicrowaveOven
{
   /**
    * Get Color of the oven
    */
    public String getColor();

   /**
    * Get Number of functions in the oven
    */
    public int getNoFunctions();

   /**
    * Get Make of the oven
    */
    public String getMake();

   /**
    * Get How long it should be heated in seconds
    */
    public int getTimer();

   /**
    * Set How long it should be heated in seconds
    */
    public void setTimer(int value);

   /**
    * Get NewAttribute4 Description
    */
    public boolean getState();

   /**
    * Starts the Oven
    *
    */
    public void start();

   /**
    * Stops the Oven
    *
    */
    public void stop();

}
